#! /usr/bin/python3
# coding=utf-8
# Button Bar
#
# apt-get install python3-gi python3-tk python3-pil python3-pil.imagetk
#
# python-Version
# + mit 2. Monitor
# 0.3
# + mit Bilder
# 0.31
#

from mybase import *
from threading import Timer
from PIL import Image, ImageTk
import tkinter as tk
from tkinter.messagebox import showinfo
import configparser,os,re

Version = '0.31'
Datum   = 'Mai 2023'

caption= 'Button Bar'
xpos   = 0
ypos   = 0
FixPos = False
width_text = 30
Farbe      = 'lightgrey'
Alpha      = 1
Schaltername = []
Befehl       = []
BefehlShow   = []
GrafikName   = []
Bilder       = False
AlleBildschirme = False
AnzMonitore     = 1
M0_width   = 0
M0_height  = 0
M1_width   = 0
M1_height  = 0

fp = os.path.dirname(os.path.realpath(__file__))
Config_Pfad = os.path.join(fp,IniFileName)

if os.path.isfile(Config_Pfad):
    config = configparser.ConfigParser()
    try:
        config.read(Config_Pfad)
        caption = config.get(Programm_sec, Name_entry, fallback = 'ButtonBar')
        xpos    = config.getint(Programm_sec, xpos_entry, fallback = 100)
        ypos    = config.getint(Programm_sec, ypos_entry, fallback = 60)
        width_text   = config.getint(Programm_sec, widthText_entry, fallback = 30)
        SchalterAnz = config.getint(Programm_sec, SchalterAnz_entry, fallback = 1)
        Farbe     = config.get(Programm_sec, HFarbe_entry, fallback ='lightgrey')
        Alpha     = config.getfloat(Programm_sec,Alpha_entry,fallback=0.9)
        FixPos    = config.getboolean(Programm_sec, FixPos_entry, fallback = True)
        Bilder    = config.getboolean(Programm_sec, Bilder_entry, fallback = False)
        BilderWidth    = config.getint(Programm_sec, BWidth_entry, fallback =100)
        BilderHeight   = config.getint(Programm_sec, BHeight_entry, fallback =100)
        BPfad     = StringTrim(config.get(Programm_sec, BPfad_entry, fallback ='Bilder'))
        Spalten   = config.getint(Programm_sec, Spalten_entry, fallback =1)
        AlleBildschirme = config.getboolean(Programm_sec, AlleBildschirme_entry, fallback = True)
        if Bilder:
            AlleBildschirme=False
        if SchalterAnz>0 :
            if SchalterAnz>20:
                SchalterAnz=20
            n = 1
            while n <= SchalterAnz:
                Schaltername.append( config.get(Schalter_sec+str(n),Name_entry,fallback = str(n)) )
                Befehl.append(StringTrim(config.get(Schalter_sec+str(n),Befehl_entry,fallback = '???')))
                BefehlShow.append(config.getint(Schalter_sec+str(n),Show_entry,fallback = 0))
                if Bilder:
                    GrafikName.append(StringTrim(config.get(Schalter_sec + str(n), Grafik_entry,fallback =  '')))
                n +=1
    except Exception as e:
        print(e)
else:
    log=('ERROR: Konfig: ' + Config_Pfad + ' nicht gefunden')
    print(log)
fenster1 = tk.Tk(className='Button Bar')
icon = tk.PhotoImage(file=os.path.join(fp,IconName))
if AlleBildschirme:
    fenster2 = tk.Toplevel(fenster1)

def SchalterClick(n):
    # print('Nummer: ' + str(n)+' Befehl: '+Befehl[n])
    bef = Befehl[n].split()
    Ausgabe = Befehl_exec(bef)
    if BefehlShow[n]==1:
        showinfo("Ausgabe", Ausgabe)

class RepeatTimer(Timer):
    def run(self):
        while not self.finished.wait(self.interval):
            self.function(*self.args, **self.kwargs)

def setMonitore(Monitore):
    # print(Monitore)
    global M0_height,M0_width,M1_height,M1_width,AlleBildschirme
    if len(Monitore) > 1 :
        Daten = re.split('x|\+', Monitore[1])
        if len(Daten) == 4:
            M1_width = int(Daten[0])
            M1_height = int(Daten[1])
    if len(Monitore) >0:
        Daten = re.split('x|\+', Monitore[0])
        if len(Daten) == 4:
            M0_width = int(Daten[0])
            M0_height = int(Daten[1])
    else:
        M0_width = fenster1.winfo_screenwidth()
        M0_height = fenster1.winfo_screenheight()

def setLeftTop():
    #print(M0_height,M0_width,M1_height,M1_width,AlleBildschirme)
    global left0,top0,left1,top1
    if xpos >= 0:
        left0 = xpos
        left1 = M0_width + xpos
    else:
        left0 = M0_width + xpos - width
        left1 = M0_width + M1_width + xpos - width
    if ypos >= 0:
        top0 = ypos
        top1 = top0
    else:
        top0 = M0_height + ypos - height
        top1 = M1_height + ypos - height

def Positioniere():
    global AnzMonitore
    Monitore = GetMonitors()
    setMonitore(Monitore)
    setLeftTop()
    fenster1.geometry('+%d+%d' % (left0, top0))
    if AlleBildschirme:
        # print(Monitore)
        if (len(Monitore)==2) and (AnzMonitore==2):
            fenster2.geometry('+%d+%d' % (left1, top1))
        elif (len(Monitore)==1) or (len(Monitore)==0):
            fenster2.withdraw()
            AnzMonitore=1
        else:
            fenster2.geometry('+%d+%d' % (left1, top1))
            fenster2.deiconify()
            AnzMonitore=2

if Bilder:
    nr = 0
    xx =1
    yy =1
    for Schalter in Schaltername:
        Pfad = os.path.join(fp,BPfad,GrafikName[nr])
        if os.path.isfile(Pfad):
            img = Image.open(Pfad).resize((BilderWidth, BilderHeight))
            Bild  = ImageTk.PhotoImage(img)
            schaltf = tk.Button(fenster1, image=Bild, command=lambda a=nr :SchalterClick(a))
            schaltf.grid(row=yy, column=xx)
            schaltf.image = Bild   # Bildobject wird gespeichert
        else:
            print('ERROR: Bilddatei existiert nicht: ' + Pfad)
            schaltf = tk.Button(fenster1,  text = '???', command=lambda a=nr: SchalterClick(a))
            schaltf.grid(row=yy, column=xx)
        xx += 1
        if xx > Spalten:
            xx =1
            yy +=1
        nr +=1
    pass
else:
    nr = 0
    for Schalter in Schaltername:
        schaltf = tk.Button(fenster1, text=Schalter, width = width_text, command=lambda a=nr :SchalterClick(a), bg=Farbe)
        schaltf.pack()
        if AlleBildschirme:
            schaltf = tk.Button(fenster2, text=Schalter, width=width_text, command=lambda a=nr: SchalterClick(a), bg=Farbe)
            schaltf.pack()
        nr += 1

fenster1.title(caption)
fenster1.attributes('-alpha',0)
fenster1.update()
width = fenster1.winfo_width()
height= fenster1.winfo_height()
Monitore = GetMonitors()
setMonitore(Monitore)
if AlleBildschirme:
    AnzMonitore = len(Monitore)
    if AnzMonitore != 2:
        AnzMonitore=1
        fenster2.withdraw
setLeftTop()
fenster1.geometry('+%d+%d'%(left0,top0))
fenster1.resizable(False,False)
fenster1.attributes('-alpha',Alpha)
fenster1.iconphoto(True, icon)
if AlleBildschirme:
    fenster2.title(caption)
    fenster2.geometry('+%d+%d' % (left0, top0))
    fenster2.resizable(False, False)
    fenster2.attributes('-alpha', Alpha)
    fenster2.iconphoto(False, icon)

Zeitdauer = 2  # Überprüfungsintervall in Sekunden
PosTimer = RepeatTimer(Zeitdauer,Positioniere)
if FixPos:
    PosTimer.start()
else:
    Positioniere()
fenster1.mainloop()
PosTimer.cancel()

exit(0)